						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Certificate Information'
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Certificate Information' AS 'Status'
									   , * 
								FROM sys.certificates

								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''

						
						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Symmetric Key Information'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Symmetric Key Information' AS 'Status'
									   , * 
								FROM sys.symmetric_keys

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Symmetric Key Information'
								PRINT ''
								PRINT ''
								PRINT ''


								SELECT 'Asymmetric Key Information' AS 'Status'
									   ,* 
								FROM sys.asymmetric_keys

						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Database Encryption Key Information'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Database Encryption Key Information' AS 'Status'
								       , * 
								FROM sys.dm_database_encryption_keys

								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'No database encryption keys found.'
									END




						/****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT ''
								PRINT 'Always Encryption'
								PRINT ''
								PRINT ''
								PRINT ''

								SELECT 'Database Encryption Key Information' AS 'Status'
								       , * 
								FROM sys.dm_database_encryption_keys

								IF @@ROWCOUNT = 0
									BEGIN
										PRINT 'No database encryption keys found.'
									END


									
					    /****************************************************************************************************/
		
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets Agent Job History retention settings'
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								CREATE TABLE #JobHistoryInfo
									(ServerName NVARCHAR(128)
									, MaxRows INT
									, MaxPerJob INT)

								DECLARE @jobhistory_max_rows INT = Null
								DECLARE @jobhistory_max_rows_per_job INT = Null
								DECLARE @server VARCHAR(50)
  
								EXECUTE master.dbo.xp_instance_regread N'HKEY_LOCAL_MACHINE',
																N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent',
																N'JobHistoryMaxRows',
																 @jobhistory_max_rows  OUTPUT,
																N'no_output'

								EXECUTE master.dbo.xp_instance_regread N'HKEY_LOCAL_MACHINE',
																N'SOFTWARE\Microsoft\MSSQLServer\SQLServerAgent',
																N'JobHistoryMaxRowsPerJob',
																 @jobhistory_max_rows_per_job  OUTPUT,
																N'no_output'

								SELECT @server = CONVERT(sysname, SERVERPROPERTY('servername'))

								INSERT INTO #JobHistoryInfo(ServerName, MaxRows, MaxPerJob) 
										VALUES ('Agent Job History Settings' , @jobhistory_max_rows, @jobhistory_max_rows_per_job)
			
								SELECT * FROM #JobHistoryInfo

								DROP TABLE #JobHistoryInfo

											    /****************************************************************************************************/
								PRINT '========================================================================================================================='
								PRINT ''
			
								PRINT ''
								PRINT 'Job Step Information'
								PRINT ''
								PRINT ''
								PRINT ''
								SELECT 'Job Step Information'  AS 'Setting'
									, [sJOB].[name] AS [JobName]
									, [sJSTP].[step_name] AS [StepName]
									, CASE [sJSTP].[subsystem]
										WHEN 'ActiveScripting' THEN 'ActiveX Script'
										WHEN 'CmdExec' THEN 'Operating system (CmdExec)'
										WHEN 'PowerShell' THEN 'PowerShell'
										WHEN 'Distribution' THEN 'Replication Distributor'
										WHEN 'Merge' THEN 'Replication Merge'
										WHEN 'QueueReader' THEN 'Replication Queue Reader'
										WHEN 'Snapshot' THEN 'Replication Snapshot'
										WHEN 'LogReader' THEN 'Replication Transaction-Log Reader'
										WHEN 'ANALYSISCOMMAND' THEN 'SQL Server Analysis Services Command'
										WHEN 'ANALYSISQUERY' THEN 'SQL Server Analysis Services Query'
										WHEN 'SSIS' THEN 'SQL Server Integration Services Package'
										WHEN 'TSQL' THEN 'Transact-SQL script (T-SQL)'
										ELSE sJSTP.subsystem
									  END AS [StepType]
									, [sPROX].[name] AS [RunAs]
									, [sJSTP].[database_name] AS [Database]
									, CASE [sJSTP].[on_success_action]
										WHEN 1 THEN 'Quit the job reporting success'
										WHEN 2 THEN 'Quit the job reporting failure'
										WHEN 3 THEN 'Go to the next step'
										WHEN 4 THEN 'Go to Step: ' 
													+ QUOTENAME(CAST([sJSTP].[on_success_step_id] AS VARCHAR(3))) 
													+ ' ' 
													+ [sOSSTP].[step_name]
									  END AS [OnSuccessAction]
									, [sJSTP].[retry_attempts] AS [RetryAttempts]
									, [sJSTP].[retry_interval] AS [RetryInterval (Minutes)]
									, CASE [sJSTP].[on_fail_action]
										WHEN 1 THEN 'Quit the job reporting success'
										WHEN 2 THEN 'Quit the job reporting failure'
										WHEN 3 THEN 'Go to the next step'
										WHEN 4 THEN 'Go to Step: ' 
													+ QUOTENAME(CAST([sJSTP].[on_fail_step_id] AS VARCHAR(3))) 
													+ ' ' 
													+ [sOFSTP].[step_name]
									  END AS [OnFailureAction]
								FROM
									[msdb].[dbo].[sysjobsteps] AS [sJSTP]
									INNER JOIN [msdb].[dbo].[sysjobs] AS [sJOB]
										ON [sJSTP].[job_id] = [sJOB].[job_id]
									LEFT JOIN [msdb].[dbo].[sysjobsteps] AS [sOSSTP]
										ON [sJSTP].[job_id] = [sOSSTP].[job_id]
										AND [sJSTP].[on_success_step_id] = [sOSSTP].[step_id]
									LEFT JOIN [msdb].[dbo].[sysjobsteps] AS [sOFSTP]
										ON [sJSTP].[job_id] = [sOFSTP].[job_id]
										AND [sJSTP].[on_fail_step_id] = [sOFSTP].[step_id]
									LEFT JOIN [msdb].[dbo].[sysproxies] AS [sPROX]
										ON [sJSTP].[proxy_id] = [sPROX].[proxy_id]
								--ORDER BY [JobName], [StepNo]

								Print '=============================================='
								PRINT '========================================================================================================================='
								PRINT ''
								PRINT ''
								PRINT 'Gets Agent Job History '
								SET NOCOUNT ON
								PRINT ''
								PRINT ''
								PRINT ''
								--https://stackoverflow.com/questions/10577676/how-to-obtain-failed-jobs-from-sql-server-agent-through-script

								    SELECT   Job.instance_id
								,SysJobs.job_id
								,SysJobs.name as 'JOB_NAME'
								,SysJobSteps.step_name as 'STEP_NAME'
								,Job.run_status
								,Job.sql_message_id
								,Job.sql_severity
								,Job.message
								,Job.exec_date
								,Job.run_duration
								,Job.server
								,SysJobSteps.output_file_name
							FROM    (SELECT Instance.instance_id
								,DBSysJobHistory.job_id
								,DBSysJobHistory.step_id
								,DBSysJobHistory.sql_message_id
								,DBSysJobHistory.sql_severity
								,DBSysJobHistory.message
								,(CASE DBSysJobHistory.run_status
									WHEN 0 THEN 'Failed'
									WHEN 1 THEN 'Succeeded'
									WHEN 2 THEN 'Retry'
									WHEN 3 THEN 'Canceled'
									WHEN 4 THEN 'In progress'
								END) as run_status
								,((SUBSTRING(CAST(DBSysJobHistory.run_date AS VARCHAR(8)), 5, 2) + '/'
								+ SUBSTRING(CAST(DBSysJobHistory.run_date AS VARCHAR(8)), 7, 2) + '/'
								+ SUBSTRING(CAST(DBSysJobHistory.run_date AS VARCHAR(8)), 1, 4) + ' '
								+ SUBSTRING((REPLICATE('0',6-LEN(CAST(DBSysJobHistory.run_time AS varchar)))
								+ CAST(DBSysJobHistory.run_time AS VARCHAR)), 1, 2) + ':'
								+ SUBSTRING((REPLICATE('0',6-LEN(CAST(DBSysJobHistory.run_time AS VARCHAR)))
								+ CAST(DBSysJobHistory.run_time AS VARCHAR)), 3, 2) + ':'
								+ SUBSTRING((REPLICATE('0',6-LEN(CAST(DBSysJobHistory.run_time as varchar)))
								+ CAST(DBSysJobHistory.run_time AS VARCHAR)), 5, 2))) AS 'exec_date'
								,DBSysJobHistory.run_duration
								,DBSysJobHistory.retries_attempted
								,DBSysJobHistory.server
								FROM msdb.dbo.sysjobhistory DBSysJobHistory
								JOIN (SELECT DBSysJobHistory.job_id
									,DBSysJobHistory.step_id
									,MAX(DBSysJobHistory.instance_id) as instance_id
									FROM msdb.dbo.sysjobhistory DBSysJobHistory
									GROUP BY DBSysJobHistory.job_id
									,DBSysJobHistory.step_id
									) AS Instance ON DBSysJobHistory.instance_id = Instance.instance_id
								WHERE DBSysJobHistory.run_status <> 1
								) AS Job
							JOIN msdb.dbo.sysjobs SysJobs
							   ON (Job.job_id = SysJobs.job_id)
							JOIN msdb.dbo.sysjobsteps SysJobSteps
							   ON (Job.job_id = SysJobSteps.job_id AND Job.step_id = SysJobSteps.step_id)