--Make sure Optimize for Ad Hoc workloads is turned on

--Run this

select * from   production.product
go
select * from production.product

--then this


SELECT    c.usecounts
		, c.objtype
		, t.text
		, q.query_plan
FROM sys.dm_exec_cached_plans AS c
	CROSS APPLY sys.dm_exec_sql_text(plan_handle) AS t
		CROSS APPLY sys.dm_exec_query_plan(plan_handle) AS q
WHERE t.text LIKE '%select% *%' AND q.dbid = 8
ORDER BY c.usecounts DESC


dbcc freeproccache
--Show no execution plan...run them both again, execution plan appears